package com.ruoyi.system.service.impl;

import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.system.domain.UpdateApp;
import com.ruoyi.system.mapper.UpdateAppMapper;
import com.ruoyi.system.service.IUpdateAppService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 【请填写功能名称】Service业务层处理
 * 
 * @author ruoyi
 * @date 2023-02-16
 */
@Service
public class UpdateAppServiceImpl implements IUpdateAppService 
{
    @Autowired
    private UpdateAppMapper updateAppMapper;

    /**
     * 查询【请填写功能名称】
     * 
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    @Override
    public UpdateApp selectUpdateAppById(Long id)
    {
        return updateAppMapper.selectUpdateAppById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     * 
     * @param updateApp 【请填写功能名称】
     * @return 【请填写功能名称】
     */
    @Override
    public List<UpdateApp> selectUpdateAppList(UpdateApp updateApp)
    {
        return updateAppMapper.selectUpdateAppList(updateApp);
    }

    /**
     * 新增【请填写功能名称】
     * 
     * @param updateApp 【请填写功能名称】
     * @return 结果
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public int insertUpdateApp(UpdateApp updateApp)
    {
        //将之前的数据全改为失效
        UpdateApp update = new UpdateApp();
        update.setIsDel("0");
        update.setModel(updateApp.getModel());
        updateAppMapper.updateUpdateAppAll(update);
        //保存当前数据
        updateApp.setCreateTime(DateUtils.getNowDate());
        return updateAppMapper.insertUpdateApp(updateApp);
    }

    /**
     * 修改【请填写功能名称】
     * 
     * @param updateApp 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int updateUpdateApp(UpdateApp updateApp)
    {
        return updateAppMapper.updateUpdateApp(updateApp);
    }

    /**
     * 批量删除【请填写功能名称】
     * 
     * @param ids 需要删除的【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteUpdateAppByIds(Long[] ids)
    {
        return updateAppMapper.deleteUpdateAppByIds(ids);
    }

    /**
     * 删除【请填写功能名称】信息
     * 
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteUpdateAppById(Long id)
    {
        return updateAppMapper.deleteUpdateAppById(id);
    }

    @Override
    public UpdateApp getInfoNew(UpdateApp updateApp) {
        updateApp.setIsDel("Y");
        UpdateApp app = updateAppMapper.getInfo(updateApp);
        if(app == null){
            app = new UpdateApp();
        }
        return app;
    }
}
